LWParser Class Reference

the main class to read a LightWay Text file More...

`#include <LWParser.hxx>`

Inheritance diagram for LWParser:

## Public Member Functions

| LWParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor More...
virtual | ~LWParser ()
| destructor More...
bool | checkHeader (MWAWHeader *header, bool strict=false)
| checks if the document header is correct (or not) More...
void | parse (WPXDocumentInterface *documentInterface)
| virtual function used to parse the input More...
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor More...
int | version () const
| returns the works version More...
void | setVersion (int vers)
| sets the works version More...

## Protected Member Functions

void | init ()
| inits all internal variables More...
void | createDocument (WPXDocumentInterface *documentInterface)
| creates the listener which will be associated to the document More...
Vec2f | getPageLeftTop () const
| returns the page left top point ( in inches) More...
bool | getColumnInfo (int &numCols, int &colSep) const
| returns the number of column and the column separator (in point) More...
void | newPage (int number)
| adds a new page More...
bool | textInDataFork () const
| returns true if the main text is in data fork More...
void | sendGraphic (int graphId)
| ask the graph parser to send a graph More...
bool | sendHeaderFooter (bool header)
| try to send the header/footer More...
bool | createZones ()
| finds the different objects zones More...
bool | readPrintInfo (MWAWEntry const &entry)
| read a PrintInfo block More...
bool | readDocInfo (MWAWEntry const &entry)
| read a DocInfo block More...
bool | readDocument (MWAWEntry const &entry)
| read a Document, Header/Footer block (1000) More...
bool | readLWSR2 (MWAWEntry const &entry)
| read a LWSR block (1002) More...
bool | readMPSR5 (MWAWEntry const &entry)
| read a MPSR block (1005) More...
bool | readTOCPage (MWAWEntry const &entry)
| read a TOC page block More...
bool | readTOC (MWAWEntry const &entry)
| read a TOC data block More...
MWAWInputStreamPtr | rsrcInput ()
| return the input input More...
libmwaw::DebugFile & | rsrcAscii ()
| a DebugFile used to write what we recognize when we parse the document in rsrc More...
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWParser (MWAWParserStatePtr state)
| constructor using a state More...
MWAWParserStatePtr | getParserState ()
| returns the parser state More...
MWAWHeader * | getHeader ()
| returns the header More...
MWAWInputStreamPtr & | getInput ()
| returns the actual input More...
MWAWContentListenerPtr & | getListener ()
| returns the listener More...
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension More...
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension More...
double | getFormLength () const
| returns the form length More...
double | getFormWidth () const
| returns the form width More...
double | getPageLength () const
| returns the page length (form length without margin ) More...
double | getPageWidth () const
| returns the page width (form width without margin ) More...
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser More...
void | setListener (MWAWContentListenerPtr &listener)
| sets the listener More...
void | resetListener ()
| resets the listener More...
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter More...
void | setFontConverter (MWAWFontConverterPtr fontConverter)
| sets the font convertor More...
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document More...
void | setAsciiName (char const *name)
| Debugging: change the default ascii file. More...
std::string const & | asciiName () const
| return the ascii file name More...

## Protected Attributes

shared_ptr < LWParserInternal::State > | m_state
| the state More...
bool | m_pageSpanSet
| a flag to know if page span has been set More...
shared_ptr< LWGraph > | m_graphParser
| the graph parser More...
shared_ptr< LWText > | m_textParser
| the text parser More...

## Friends

class | LWParserInternal::SubDocument
class | LWGraph
class | LWText

## Detailed Description

the main class to read a LightWay Text file

## Constructor & Destructor Documentation

LWParser::LWParser | ( | MWAWInputStreamPtr | input,
|  | MWAWRSRCParserPtr | rsrcParser,
|  | MWAWHeader * | header
| ) |  |

constructor

LWParser::~LWParser | ( |  | ) |

virtual

destructor

## Member Function Documentation

bool LWParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = `false`
| ) |  |

virtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by parse().

void LWParser::createDocument | ( | WPXDocumentInterface * | documentInterface | ) |

protected

creates the listener which will be associated to the document

Referenced by parse().

bool LWParser::createZones | ( |  | ) |

protected

finds the different objects zones

Referenced by parse().

bool LWParser::getColumnInfo | ( | int & | numCols,
|  | int & | colSep
| ) |  | const

protected

returns the number of column and the column separator (in point)

Referenced by LWText::sendMainText().

Vec2f LWParser::getPageLeftTop | ( |  | ) | const

protected

returns the page left top point ( in inches)

void LWParser::init | ( |  | ) |

protected

inits all internal variables

Referenced by LWParser().

void LWParser::newPage | ( | int | number | ) |

protected

adds a new page

void LWParser::parse | ( | WPXDocumentInterface * | documentInterface | ) |

virtual

virtual function used to parse the input

Implements MWAWParser.

bool LWParser::readDocInfo | ( | MWAWEntry const & | entry | ) |

protected

read a DocInfo block

Referenced by createZones().

bool LWParser::readDocument | ( | MWAWEntry const & | entry | ) |

protected

read a Document, Header/Footer block (1000)

Referenced by createZones().

bool LWParser::readLWSR2 | ( | MWAWEntry const & | entry | ) |

protected

read a LWSR block (1002)

Referenced by createZones().

bool LWParser::readMPSR5 | ( | MWAWEntry const & | entry | ) |

protected

read a MPSR block (1005)

Referenced by createZones().

bool LWParser::readPrintInfo | ( | MWAWEntry const & | entry | ) |

protected

read a PrintInfo block

Referenced by createZones().

bool LWParser::readTOC | ( | MWAWEntry const & | entry | ) |

protected

read a TOC data block

Referenced by createZones().

bool LWParser::readTOCPage | ( | MWAWEntry const & | entry | ) |

protected

read a TOC page block

Referenced by createZones().

libmwaw::DebugFile & LWParser::rsrcAscii | ( |  | ) |

protected

a DebugFile used to write what we recognize when we parse the document in rsrc

Referenced by readDocInfo(), readDocument(), LWText::readDocumentHF(), LWText::readFont2(), LWText::readFonts(), readLWSR2(), readMPSR5(), readPrintInfo(), LWText::readRuby(), LWText::readRulers(), LWText::readStyleU(), readTOC(), readTOCPage(), LWText::readUnknownStyle(), LWGraph::sendJPEG(), and LWText::sendMainText().

MWAWInputStreamPtr LWParser::rsrcInput | ( |  | ) |

protected

return the input input

Referenced by readDocInfo(), readDocument(), LWText::readDocumentHF(), LWText::readFont2(), LWText::readFonts(), readLWSR2(), readMPSR5(), readPrintInfo(), LWText::readRuby(), LWText::readRulers(), LWText::readStyleU(), readTOC(), readTOCPage(), LWText::readUnknownStyle(), sendGraphic(), sendHeaderFooter(), LWText::sendHeaderFooter(), LWGraph::sendJPEG(), and LWText::sendMainText().

void LWParser::sendGraphic | ( | int | graphId | ) |

protected

ask the graph parser to send a graph

Referenced by LWText::sendMainText().

bool LWParser::sendHeaderFooter | ( | bool | header | ) |

protected

try to send the header/footer

bool LWParser::textInDataFork | ( |  | ) | const

protected

returns true if the main text is in data fork

Referenced by LWText::sendMainText().

## Friends And Related Function Documentation

friend class LWGraph

friend

Referenced by init().

friend class LWParserInternal::SubDocument

friend

friend class LWText

friend

Referenced by init().

## Member Data Documentation

shared_ptr<LWGraph> LWParser::m_graphParser

protected

the graph parser

Referenced by createDocument(), createZones(), init(), parse(), and sendGraphic().

bool LWParser::m_pageSpanSet

protected

a flag to know if page span has been set

Referenced by readDocument(), and readPrintInfo().

shared_ptr<LWParserInternal::State> LWParser::m_state

protected

the state

Referenced by checkHeader(), createDocument(), getColumnInfo(), getPageLeftTop(), init(), newPage(), readDocument(), and textInDataFork().

shared_ptr<LWText> LWParser::m_textParser

protected

the text parser

Referenced by createDocument(), createZones(), init(), parse(), readDocument(), and sendHeaderFooter().

The documentation for this class was generated from the following files:

- LWParser.hxx
- LWParser.cxx